/*
some code from berlios
some code from iceepg

*/
#include <tap.h>
#include "exTap.h"
#include "tf5800.h"

type_state state_str[] = {
    {   8,                      "UNKNOWN ", },
    {   STATE_Normal,           "Normal  ", },
    {   STATE_Menu,             "Menu    ", },
    {   STATE_Epg,              "Epg     ", },
    {   STATE_List,             "List    ", },
    {   STATE_Ttx,              "Ttx     ", },
    {   STATE_Game,             "Game    ", },
    {   STATE_FileList,         "FileList", },
    {   STATE_Tap,              "Tap     ", },
};

type_state substate_str[] = {
    {   0x30,                           "UNKNOWN            ", },
    {   SUBSTATE_MainMenu,              "MainMenu           ", },
    {   SUBSTATE_TimeMenu,              "TimeMenu           ", },
    {   SUBSTATE_TimeSettingMenu,       "TimeSettingMenu    ", },
    {   SUBSTATE_InstallationMenu,      "InstallationMenu   ", },
    {   SUBSTATE_TimerMenu,             "TimerMenu          ", },
    {   SUBSTATE_LanguageMenu,          "LanguageMenu       ", },
    {   SUBSTATE_ParentMenu,            "ParentMenu         ", },
    {   SUBSTATE_ParentLockMenu,        "ParentLockMenu     ", },
    {   SUBSTATE_AvMenu,                "AvMenu             ", },
    {   SUBSTATE_ChListMenu,            "ChListMenu         ", },
    {   SUBSTATE_FavChListMenu,         "FavChListMenu      ", },
    {   SUBSTATE_SearchMenu,            "SearchMenu         ", },
    {   SUBSTATE_LnbSettingMenu,        "LnbSettingMenu     ", },
    {   SUBSTATE_Diseqc12SettingMenu,   "Diseqc12SettingMenu", },
    {   SUBSTATE_USALSMenu,             "USALSMenu          ", },
    {   SUBSTATE_CiMenu,                "CiMenu             ", },
    {   SUBSTATE_Ci,                    "Ci                 ", },
    {   SUBSTATE_CiSlotMenu,            "CiSlotMenu         ", },
    {   SUBSTATE_SatSearch,             "SatSearch          ", },
    {   SUBSTATE_TpSearch,              "TpSearch           ", },
    {   SUBSTATE_SmatvSearch,           "SmatvSearch        ", },
    {   SUBSTATE_ChannelEditMenu,       "ChannelEditMenu    ", },
    {   SUBSTATE_InformationMenu,       "InformationMenu    ", },
    {   SUBSTATE_SystemMenu,            "SystemMenu         ", },
    {   SUBSTATE_GameMenu,              "GameMenu           ", },
    {   SUBSTATE_OtaMenu,               "OtaMenu            ", },
    {   SUBSTATE_IrdStatus,             "IrdStatus          ", },
    {   SUBSTATE_Carlendar,             "Carlendar          ", },
    {   SUBSTATE_PvrRecord,             "PvrRecord          ", },
    {   SUBSTATE_PvrReservation,        "PvrReservation     ", },
    {   SUBSTATE_ReservationList,       "ReservationList    ", },
    {   SUBSTATE_Normal,                "Normal             ", },
    {   SUBSTATE_Audio,                 "Audio              ", },
    {   SUBSTATE_Subt,                  "Subt               ", },
    {   SUBSTATE_Ttx,                   "Ttx                ", },
    {   SUBSTATE_Fav,                   "Fav                ", },
    {   SUBSTATE_Sat,                   "Sat                ", },
    {   SUBSTATE_PvrTimeSearch,         "PvrTimeSearch      ", },
    {   SUBSTATE_PvrPlayingSearch,      "PvrPlayingSearch   ", },
    {   SUBSTATE_PvrRecSearch,          "PvrRecSearch       ", },
    {   SUBSTATE_PipList,               "PipList            ", },
    {   SUBSTATE_Multifeed,             "Multifeed          ", },
    {   SUBSTATE_List,                  "List               ", },
    {   SUBSTATE_Epg,                   "Epg                ", },
    {   SUBSTATE_Game,                  "Game               ", },
    {   SUBSTATE_PvrList,               "PvrList            ", },
    {   SUBSTATE_ExeList,               "ExeList            ", },
    {   SUBSTATE_Exec,                  "Exec               ", },
    {   SUBSTATE_TtxEmul,               "TtxEmul            ", },
};

type_state running_status_str[] = {
    {   5,  "UNKNOWN    ",  },
    {   0,  "Not Running",  },
    {   1,  "Next",         },
    {   2,  "Starts Soon",  },
    {   3,  "Pausing    ",  },
    {   4,  "Running    ",  },
};

type_state rating_str[] = {
    {    6,     "??",       },
    {    6,     "P?",       },
    {   10,     "G ",       },
    {   12,     "PG",       },
    {   13,     "M ",       },
    {   15,     "MA",       },
    {   18,     "R ",       },
};


type_state rectype_str[] = {
    {   4,                  "UNKNOWN  ",    },
    {   RECTYPE_None,       "None     ",    },
    {   RECTYPE_Normal,     "Normal   ",    },
    {   RECTYPE_Timeshift,  "Timeshift",    },
    {   RECTYPE_Copy,       "Copy     ",    },
};

type_state timer_rectype_str[] = {
    {   2,       "UNKNOWN  ",   },
    {   0,       "VCR Timer",   },
    {   1,       "Recording",   },
};

type_state reserve_type_str[] = {
    {   6,                          "UNKNOWN      ",    },
    {   RESERVE_TYPE_Onetime,       "Onetime      ",    },
    {   RESERVE_TYPE_Everyday,      "Everyday     ",    },
    {   RESERVE_TYPE_EveryWeekend,  "EveryWeekend ",    },
    {   RESERVE_TYPE_Weekly,        "Weekly       ",    },
    {   RESERVE_TYPE_WeekDay,       "WeekDay      ",    },
    {   N_ReserveType,              "N_ReserveType",    },
};

type_state service_type_str[] = {
    {   2,                  "UNKNOWN",     },
    {   SVC_TYPE_Tv,        "TV     ",     },
    {   SVC_TYPE_Radio,     "Radio  ",     },
};

type_state playmode_str[] = {
    {   6,                    "UNKNOWN",      },
    {   PLAYMODE_None,        "None",         },
    {   1,                    "???",          },
    {   PLAYMODE_Playing,     "Playing",      },
    {   PLAYMODE_TempPlaying, "TempPlaying",  },
    {   PLAYMODE_RecPlaying,  "RecPlaying",   },
    {   PLAYMODE_Mp3,         "MP3",          },
};

type_state trickmode_str[] = {
    {   5,                 "UNKNOWN",      },
    {   TRICKMODE_Normal,  "Normal",       },
    {   TRICKMODE_Forward, "Forward",      },
    {   TRICKMODE_Rewind,  "Rewind",       },
    {   TRICKMODE_Slow,    "Slow",         },
    {   TRICKMODE_Pause,   "Pause",        },
};

type_state screen_ratio_str[] = {
    {   2,                  "???",     },
    {	SCREEN_RATIO_4_3,   "4:3",     },
	{	SCREEN_RATIO_16_9,  "16:9",    },
};

type_state display_mode_str[] = {
    {   2,                          "UNKNOWN  ",       },
    {	DISPLAY_MODE_LetterBox,     "Letter Box",      },
	{	DISPLAY_MODE_CenterExtract, "Center Extract",  },
};

type_state attribute_str[] = {
    {   7,              "???",      },
    {   ATTR_NORMAL,    "STD",      },
    {   ATTR_TS,        " TS",      },
    {   ATTR_PROGRAM,   "PRG",      },
    {   ATTR_DOTDOT,    " ..",      },
    {   ATTR_DOT,       "  .",      },
    {   ATTR_FOLDER,    "DIR",      },
    {   ATTR_RECYCLE,   "RCY",      },      //__RECYCLE__
};


char *get_str(type_state *str, int index)
{
    int i;

//    for (i=1; i<(sizeof(str)/sizeof(type_state)); i++) {
    for (i=1; i<=str[0].value; i++) {
        if (str[i].value == index) {
            return str[i].string;
        }
    }
    return str[0].string;
}

//----------------------------------------------------------------------------
//
//menu stuff
//

void ShowMenu(type_menu *menu)
{
    int i;
    int num_items;
    int y,h;

    if (!menu->visible) {
        TAP_ExitNormal();
        menu->rgn = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
        if ((short)menu->rgn == -1) return;
        TAP_Win_SetDefaultColor(&menu->win);
        num_items = menu->item[0].id;
        h = (num_items + 1)* 20;
        h = (h < 80) ? 80 : h;
        h = (h > 280) ? 280 : h;
        y = 248 - (num_items * 10);
        y = (y < 50) ? 50 : y;
        y = (y > 250) ? 250 : y;
        //x,y,width,height
        TAP_Win_Create(&menu->win, (word)menu->rgn, 200, y, 300, h, FALSE, FALSE);
        TAP_Win_SetTitle(&menu->win, ptrfix(menu->fixme_titlep), 0, FNT_Size_1622);
//        TAP_Win_SetTitle(&menu->win, menu->title, 0, FNT_Size_1622);
        for (i=1; i<=menu->item[0].id; i++) {
            TAP_Win_AddItem(&menu->win, menu->item[i].str);
        }
        TAP_Win_SetSelection(&menu->win, 0);
        menu->visible = 1;
    }
}

void DeleteMenu(type_menu *menu)
{
    if (menu->visible) {
        TAP_Win_Delete(&menu->win);
        TAP_Osd_Delete(menu->rgn);
        TAP_EnterNormal();
        menu->visible = 0;
    }
}

dword message_showing = 0;
word message_rgn = 0;

//void ShowMessage(char* lpMessage, char* lpMessage1, dword dwDelay)
//{
//  word rgn;                                                           // stores rgn-handle for osd
//  dword w;                                                            // stores width of message-text
//
//  rgn = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);                 // create rgn-handle
//  if (rgn == (short)-1) return 0;
//  w = TAP_Osd_GetW(lpMessage, 0, FNT_Size_1622) + 10;             // calculate width of message
//  if (TAP_Osd_GetW(lpMessage1, 0, FNT_Size_1622) + 10>w) {
//      w = TAP_Osd_GetW(lpMessage1, 0, FNT_Size_1622) + 10;            // if second message is larger, calculate new width of message
//    }
//
//  if (w > 720) w = 720;                                               // if message is too long
//  TAP_Osd_FillBox(rgn, (720-w)/2-5, 265, w+10, 54, RGB(19,19,19));    // draw background-box for border
//
//  TAP_Osd_PutS(rgn, (720-w)/2, 270, (720+w)/2, lpMessage,
//      RGB(31,31,31), RGB(3,5,10), 0, FNT_Size_1622, FALSE, ALIGN_CENTER);  // show 1. message
//  TAP_Osd_PutS(rgn, (720-w)/2, 270+22, (720+w)/2, lpMessage1,
//      RGB(31,31,31), RGB(3,5,10), 0, FNT_Size_1622, FALSE, ALIGN_CENTER);  // show 2. message
//  TAP_Delay(dwDelay);                                                 // show it for dwDelay /100 seconds
//  TAP_Osd_Delete(rgn);                                                // release rgn-handle
//}
dword ShowMessage(char *lpMessage, char *lpMessage1, dword dwDelay, int wait)
{
    word rgn = 0;                                                       // stores rgn-handle for osd
    dword w1,w2;                                                        // stores width of message-text
    int i;
    dword w = 430;
    char Message2[0x40];

    //clear out any old ones
    if (message_rgn && message_showing) {
        TAP_Osd_Delete(message_rgn);
        message_rgn = 0;
        message_showing = 0;
    }

    if (wait) {
        rgn = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);      // create rgn-handle
        if ((short)rgn == -1) {
            TAP_Print("\nShowMessage_y(rgn=%x)", rgn);
            return 0;
        }
    }
    else {
        if (message_rgn == 0) {
            rgn = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);      // create rgn-handle
            if ((short)rgn == -1) {
                TAP_Print("\nShowMessage_y(rgn=%x)", rgn);
                return 0;
            }
            message_rgn = rgn;
        }
    }

    w1 = TAP_Osd_GetW(lpMessage, 0, FNT_Size_1622) + 10;                // calculate width of message
    if (w1 > w) w1 = w;                                                 // if message is too long
    w2 = TAP_Osd_GetW(lpMessage1, 0, FNT_Size_1622) + 10;               // calculate width of message

    TAP_Osd_FillBox(rgn, (720-w)/2-5, 265, w+10, 54+22*(strlen(lpMessage1)/50), RGB(19,19,19)); // draw background-box for border

    TAP_Osd_PutS(rgn, (720-w)/2, 270, (720+w)/2, lpMessage,
        COLOR_White, RGB(3,5,10), 0, FNT_Size_1622, FALSE, ALIGN_CENTER);    // show 1. message

    for(i=0; i<(int)strlen(lpMessage1); i+=50) {
        memcpy(Message2, &lpMessage1[i], 50);
        Message2[50] = '\0';
        TAP_Osd_PutS(rgn, (720-w)/2, 270+22*((i+50)/50), (720+w)/2, Message2,
            COLOR_White, RGB(3,5,10), 0, FNT_Size_1622, FALSE, ALIGN_CENTER);    // show 2. message
    }
    if (wait) {
        TAP_Delay(dwDelay);                                             // show it for dwDelay /100 seconds
        TAP_Osd_Delete(rgn);                                            // release rgn-handle
        rgn = 0;
    }
    else {
        //schedule delete
        message_showing = TAP_GetTick() + dwDelay;
        return message_rgn;
    }
    return 0;
}

dword ShowMessage_y(char *lpMessage, int y, dword bkcolour, dword dwDelay, int wait)
{
    word rgn;
    int i;
    int w;
    char Message2[0x100];
    char *chrp;
    char *max_startp;
    int max_width = 0;
    char *startp;
    int lines;
    int width;

    //delete any old ones
//but not if a menu is showing?

    if (message_rgn && message_showing) {
        TAP_Osd_Delete(message_rgn);
        message_rgn = 0;
        message_showing = 0;
    }

    if (wait) {
        rgn = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
        if ((short)rgn == -1) {
            TAP_Print("\nShowMessage_y(rgn=%x)", rgn);
            return 0;
        }
    }
    else {
        if (message_rgn == 0) {
            rgn = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
            if ((short)rgn == -1) {
                TAP_Print("\nShowMessage_y(rgn=%x)", rgn);
                return 0;
            }
            message_rgn = rgn;
        }
        else {
            rgn = message_rgn;
        }
    }

    //split the message into lines
    //get the wdith of the longest line
    chrp = lpMessage;
    max_startp = chrp;
    max_width = 0;
    lines = 0;
    width = 0;
    startp = chrp;
    while(1) {
        width ++;
        if ((*chrp == 0x0a) || (*chrp == 0x00)) {
            lines ++;
            if (width > max_width) {
                max_startp = startp;
                max_width = width;
            }
            width = 0;
            startp = chrp;
        }
        if (*chrp == 0) break;
        chrp++;
    }

    //draw the background box
    w = TAP_Osd_GetW(max_startp, 0, FNT_Size_1622) + 10;                            // calculate width of message
//TAP_Print("\ny=%d, max_width=%d, lines=%d, w=%d", y, max_width, lines, w);
    w = (w>720) ? 720 : w;
//tbd: adjust y to stop going off bottom of screen
    y = ((y+32+22*(lines-1))>576) ? (576-32-22*(lines-1)) : y;
    TAP_Osd_FillBox(rgn, (720-w)/2-5, y, w+10, 32+22*(lines-1), RGB(19,19,19));     // draw background-box for border


    chrp = lpMessage;
    lines = 0;
    width = 0;
    startp = chrp;
    while(1) {
        width ++;
        if ((*chrp == 0x0a) || (*chrp == 0x00)) {
            strncpy(Message2, startp, width);
            Message2[width] = '\0';
            TAP_Osd_PutString(rgn, (720-w)/2, 5+y+22*((lines)), (720+w)/2, Message2,
                COLOR_White, RGB(3,5,10), 0, FNT_Size_1622, 1);//FALSE, ALIGN_CENTER);   // show message
            lines ++;
            width = 0;
            startp = chrp;
        }
        if (*chrp == 0) break;
        chrp++;
    }

    if (wait) {
        TAP_Delay(dwDelay);         // show it for dwDelay /100 seconds
        TAP_Osd_Delete(rgn);
        rgn = 0;
    }
    else {
        //schedule delete
        message_showing = TAP_GetTick() + dwDelay;
        return message_rgn;
    }
    return 0;
}

dword ShowMessage2(char *lpMessage, dword dwDelay, int wait)
{
    return ShowMessage_y(lpMessage, 265, RGB(3,5,10), dwDelay, wait);
}

dword ShowMessage_low(char *lpMessage, dword dwDelay, int wait)
{
    return ShowMessage_y(lpMessage, 500, RGB(3,5,10), dwDelay, wait);
}


//<5. five     > yellow on purple background
void ShowSvcnumWin(int svc)
{
    word rgn = 0;
    TYPE_TapChInfo info;
    int ret;
    char strTemp[0x40];

    TAP_Channel_GetInfo(0, svc, &info);
    sprintf(strTemp, "%d. %s", info.logicalChNum, info.chName);


//    ret = IsChannelInfoShown();        //takes 20ms
//    if (ret) {
//        return;
//    }
    rgn = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);             // create rgn-handle
    if ((short)rgn == -1) return;

    TAP_Osd_PutS((word)rgn, 544-25, 36, (720)-40, strTemp,            // show message
        RGB(31,31,0), RGB(20,0,20), 0, FNT_Size_1622, FALSE, ALIGN_LEFT);
    TAP_Delay(120);                                             // show it for 1.2 seconds
    TAP_Osd_Delete(rgn);                                        // release rgn-handle
}

//----------------------------------------------------------------------------
//
//log stuff
//

//
//print messages to serial port, screen, or file
//
char strLog[0x100];
TYPE_File *OpLog = 0;

int log_message(int log, char *str, int delay)
{
    char filename[] = "exTAP.log";
    char logmsg_file[] = "\nlog: ";

    if (log & LOG_SERIAL) {
        TAP_Print("\n%s: %s", tap_name, str);
    }
//    if (log & LOG_SCREEN_CONT) {
//        ShowMessage(tap_name, str, delay, 0);
//    }
//    if (log & LOG_SCREEN_WAIT) {
//        ShowMessage(tap_name, str, delay, 1);
//    }
    if (log & LOG_SCREEN_CONT) {
        ShowMessage2(str, delay, 0);
    }
    if (log & LOG_SCREEN_WAIT) {
        ShowMessage2(str, delay, 1);
    }
    if (log & LOG_FILE) {
        if (!OpLog) {
            TAP_Hdd_ChangeDir("/");
            TAP_Hdd_ChangeDir("ProgramFiles");
            //if exists delete it
            if (TAP_Hdd_Exist(filename)) {
                TAP_Hdd_Delete(filename);
            }
            TAP_Hdd_Create(filename, ATTR_NORMAL);
            OpLog = TAP_Hdd_Fopen(filename);
            if (!OpLog) {
                sprintf(strLog, "ERROR: cannot open logfile, %s", filename);
                log_message(LOG_SCREEN_WAIT|LOG_SERIAL, strLog, DELAY_SHORT);
                return -1;
            }
        }
        TAP_Hdd_Fwrite(logmsg_file, strlen(logmsg_file), 1, OpLog);
        TAP_Hdd_Fwrite(str, strlen(str), 1, OpLog);
    }
    return 0;
}

//----------------------------------------------------------------------------
//
//date stuff
//
char *day_str[] = {"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday","Sunday"};

char *getdow(int mjd)
{
    return day_str[(mjd + 3) % 7];
//???    return day_str[((mjd + 2) % 7) + 1];
}

int getmjd(word mjd, byte *day, byte *month, word *year)
{
    int yy,mm,k;

#ifdef _WIN32
    yy = (int)((mjd - 15078.2) / 365.25);
    mm = (int) ((mjd - 14956.1 - (int) (yy * 365.25)) / 30.6001);
    k = ((mm == 14) || (mm == 15)) ? 1 : 0;
    *day = (byte)(mjd - 14956 - (int)(yy * 365.25) - (int)(mm * 30.6001));
    *month = (byte)(mm - 1 - k * 12);
    *year = (word)(1900 + yy + k);
#else
    byte weekDay;

    TAP_ExtractMjd(mjd, year, month, day, &weekDay);
#endif
    return 0;
}

char mjdstr[0x20];

char *mjd_to_string(word mjd)
{
    byte day, month;
    word year;

    getmjd(mjd, &day, &month, &year);
    sprintf(mjdstr, "%02d/%02d/%04d", day, month, year);
    return mjdstr;
}

int setmjd(int day, int month, int year)
{
    int k;
    int mjd;

#ifdef _WIN32
    k = ((month == 1) || (month == 2)) ? 1 : 0;
    mjd = 14956 + day + (int)((year - 1900 - k) * 365.25) + (int)((month + 1 + k * 12) * 30.6001);
#else
    mjd = (int)TAP_MakeMjd((word)year, (byte)month, (byte)day);
#endif
    return mjd;
}

//----------------------------------------------------------------------------
//
//misc stuff
//
void dump(dword addr, int length)
{
    int i,j;
    byte buf[0x10];

    for (i=0; i<length; i+=0x10) {
        TAP_Print("\n%08x : ",addr+i);
        for (j=0; j<0x10; j++) {
            buf[j] = *(byte *)(addr+i+j);
        }
        for (j=0; j<0x10; j++) {
            if ((i+j)<length) {
                TAP_Print("%02x ", buf[j]);
            }
            else {
                TAP_Print("   ");
            }
        }
        TAP_Print("  ");
        for (j=0; j<0x10; j++) {
            if ((i+j)<length) {
                TAP_Print("%c", to_printable(buf[j]));
            }
            else {
                TAP_Print(" ");
            }
        }
    }
    TAP_Print("\n");
}

void dump16(dword addr, int length)
{
    int i,j;
    word buf[0x10/2];

    for (i=0; i<length; i+=0x10) {
        TAP_Print("\n%08x : ",addr+i);
        for (j=0; j<(0x10/2); j++) {
            buf[j] = *(word *)(addr+i+(2*j));
        }
        for (j=0; j<(0x10/2); j++) {
            if ((i+(2*j))<length) {
                TAP_Print("%04x ", buf[j]);
            }
            else {
                TAP_Print("   ");
            }
        }
        TAP_Print("  ");
        for (j=0; j<0x10; j++) {
            if ((i+j)<length) {
                TAP_Print("%c", to_printable(((buf[j/2]>>(8*((1-j&1)))) & 0xff)));
            }
            else {
                TAP_Print(" ");
            }
        }
    }
    TAP_Print("\n");
}


void dump32(dword addr, int length)
{
    int i,j;
    dword buf[0x20/4];

    for (i=0; i<length; i+=0x20) {
        TAP_Print("\n%08x : ",addr+i);
        for (j=0; j<(0x20/4); j++) {
            buf[j] = *(dword *)(addr+i+(4*j));
        }
        for (j=0; j<(0x20/4); j++) {
            if ((i+(4*j))<length) {
                TAP_Print("%08x ", buf[j]);
            }
            else {
                TAP_Print("   ");
            }
        }
        TAP_Print("  ");
        for (j=0; j<0x20; j++) {
            if ((i+j)<length) {
                TAP_Print("%c", to_printable(((buf[j/4]>>(8*((3-j&3)))) & 0xff)));
            }
            else {
                TAP_Print(" ");
            }
        }
    }
    TAP_Print("\n");
}

void dump_reg(type_hook_registers *reg)
{
    TAP_Print("\n");
    TAP_Print("\n$0  %08x  $t0 %08x  $s0 %08x  $t8 %08x", reg->zero, reg->t0, reg->s0, reg->t8);
    TAP_Print("\n$at %08x  $t1 %08x  $s1 %08x  $t9 %08x", reg->at, reg->t1, reg->s1, reg->t9);
    TAP_Print("\n$v0 %08x  $t2 %08x  $s2 %08x  $k0 %08x", reg->v0, reg->t2, reg->s2, reg->k0);
    TAP_Print("\n$v1 %08x  $t3 %08x  $s3 %08x  $k1 %08x", reg->v1, reg->t3, reg->s3, reg->k1);
    TAP_Print("\n$a0 %08x  $t4 %08x  $s4 %08x  $gp %08x", reg->a0, reg->t4, reg->s4, reg->gp);
    TAP_Print("\n$a1 %08x  $t5 %08x  $s5 %08x  $sp %08x", reg->a1, reg->t5, reg->s5, reg->sp);
    TAP_Print("\n$a2 %08x  $t6 %08x  $s6 %08x  $s8 %08x", reg->a2, reg->t6, reg->s6, reg->s8);
    TAP_Print("\n$a3 %08x  $t7 %08x  $s7 %08x  $ra %08x", reg->a3, reg->t7, reg->s7, reg->ra);
    TAP_Print("\n");
}
int dump_channels(void)
{
    int i;
    int nTvSvc;
    int nRadioSvc;
    TYPE_TapChInfo channel_info;

    TAP_Channel_GetTotalNum(&nTvSvc, &nRadioSvc);
    for (i=0; i<nTvSvc; i++) {
        TAP_Channel_GetInfo(SVC_TYPE_Tv, i, &channel_info);
        TAP_Print("\n%2d, (%3d), %16s", i, channel_info.logicalChNum, channel_info.chName);
        TAP_Print(", onid:%04x, tsid:%04x, svcid:%04x", channel_info.orgNetId, channel_info.tsId, channel_info.svcId);
    }

    TAP_Channel_GetTotalNum(&nTvSvc, &nRadioSvc);
    for (i=0; i<nRadioSvc; i++) {
        TAP_Channel_GetInfo(SVC_TYPE_Radio, i, &channel_info);
        TAP_Print("\n%2d, (%3d), %16s", i, channel_info.logicalChNum, channel_info.chName);
        TAP_Print(", onid:%04x, tsid:%04x, svcid:%04x", channel_info.orgNetId, channel_info.tsId, channel_info.svcId);
    }

    return 0;
}

//still a bit crap
int get_channel_number(int service_id)
{
    int i;
    int nTvSvc, nRadioSvc;
    int num_channels;
    TYPE_TapChInfo chInfo;

    TAP_Channel_GetTotalNum(&nTvSvc, &nRadioSvc);
    for (i=0; i<nTvSvc; i++) {
        TAP_Channel_GetInfo(SVC_TYPE_Tv, i, &chInfo);
        if (service_id == chInfo.svcId) {
            return chInfo.logicalChNum;
        }
    }
    for (i=0; i<nRadioSvc; i++) {
        TAP_Channel_GetInfo(SVC_TYPE_Radio, i, &chInfo);
        if (service_id == chInfo.svcId) {
            return chInfo.logicalChNum;
        }
    }
    num_channels = nTvSvc + nRadioSvc;
    sprintf(strLog,"ERROR: get_channel_number() failed,  num_channels=%d, service_id=%04x", num_channels, service_id);
    log_message(LOG_SCREEN_CONT|LOG_SERIAL, strLog, DELAY_LONG);
    return -1;
}

void status()
{
    dword state, subState;
    int channel_type, channel_number;
    TYPE_TapChInfo channel_info;

    TAP_Print("\n");
    TAP_GetState(&state, &subState);
    TAP_Print("\nTAP_GetState()                  = %s %s", get_str(state_str, state), get_str(substate_str, subState));

    if (TAP_Channel_IsStarted(CHANNEL_Main)) {
        TAP_Channel_GetCurrent(&channel_type, &channel_number);
        TAP_Channel_GetInfo(channel_type, channel_number, &channel_info);
        TAP_Print("\nTAP_Channel_GetCurrent()        = %d, %s, %s", channel_number, channel_info.chName, get_str(service_type_str, channel_type));
    }

    if (TAP_Channel_IsStarted(CHANNEL_Sub)) {
        TAP_Channel_GetCurrentSubTV(&channel_number);
        TAP_Channel_GetInfo(SVC_TYPE_Tv, channel_number, &channel_info);
        TAP_Print("\nTAP_Channel_GetCurrentSubTV()   = %d, %s", channel_number, channel_info.chName);
    }
}

//----------------------------------------------------------------------------
//
//
//
static char dateStr[0x20];

char *mjdToString(dword date_time)
{
    type_taptime *time;
    word year;
    byte month, day, weekDay;

    memset(dateStr, 0x0, 0x20);
    time = (type_taptime *)&date_time;
    if (time->mjd < 15079) {
        time->hour = 0;
        time->minute = 0;
        day = 0;
        month = 0;
        year = 0;
    }
    else {
        TAP_ExtractMjd(time->mjd, &year, &month, &day, &weekDay);
    }
    sprintf(dateStr, "%02d:%02d:%02d %02d/%02d/%04d", (int)time->hour, (int)time->minute, 0, (int)day, (int)month, (int)year);
    return dateStr;
}

char *padString(char *in, int len)
{
    static char tmpStr[1024];
    int in_len, padLen, idx;

    if (len > 1023) len = 1023;

    in_len = strlen(in);

    memset(tmpStr, 0x0, 1024);
    strncpy(tmpStr, in, in_len);

    padLen = len - in_len;

    for(idx=0; idx < padLen; idx++) {
        tmpStr[in_len+idx] = ' ';
    }
    return tmpStr;
}

//----------------------------------------------------------------------------
//
//
//
int IsChannelInfoShown(void)
{
    TYPE_OsdBaseInfo OsdBaseInfo;           // stores OSD BaseInfo
    word *_vAddr[576];                      // stores vertical addresses
    dword i;                                // stores loop-variable for building addresses
    dword x;                                // stores x-position for screen-scan
    dword y;                                // stores y-position for screen-scan

    TAP_Osd_GetBaseInfo(&OsdBaseInfo);      // get baseaddresses of screen-buffer
    for(i=0; i<576; i+=2) {                 // set vertical address
        _vAddr[i] = (word *)((dword)OsdBaseInfo.eAddr + 720*i);
        _vAddr[i+1] = (word *)((dword)OsdBaseInfo.oAddr + 720*i);
    }
    for(y=0; y<200; y+=2) {                 // scan entire screen-buffer
        for (x=300; x<650; x+=2) {
            if ((*(_vAddr[y]+x)) != 0)      // if any value then graphics are shown
                return TRUE;                // return that something is on the screen
        }
    }
    return FALSE;                           // return that nothing is on screen
}

int IsAnythingShown(void)
{
    TYPE_OsdBaseInfo OsdBaseInfo;           // stores OSD BaseInfo
    word *_vAddr[576];                      // stores vertical addresses
    dword i;                                // stores loop-variable for building addresses
    dword x;                                // stores x-position for screen-scan
    dword y;                                // stores y-position for screen-scan

    TAP_Osd_GetBaseInfo(&OsdBaseInfo);      // get baseaddresses of screen-buffer
    for(i=0; i<576; i+=2) {                 // set vertical address
        _vAddr[i] = (word *)((dword)OsdBaseInfo.eAddr + 720*i);
        _vAddr[i+1] = (word *)((dword)OsdBaseInfo.oAddr + 720*i);
    }
    for(y=200; y<576; y+=2) {               // scan entire screen-buffer
        for (x=0; x<720; x+=4) {
            if ((*(_vAddr[y]+x)) != 0)      // if any value then graphics are shown
                return TRUE;                // return that somewhat is on the screen
        }
    }
    return FALSE;                           // return that nothing is on screen
}

int OsdActive(int iStartingRow, int iEndingRow)
{
    TYPE_OsdBaseInfo OsdBaseInfo;
    word* pAddr[576];
    int i, x, y;

    TAP_Osd_GetBaseInfo(&OsdBaseInfo);          // retrieve current OSD
    for (i=iStartingRow; i<iEndingRow; i+=2) {
        pAddr[i] = (word *)((dword)OsdBaseInfo.eAddr + 720*i);   //even field
        pAddr[i+1] = (word *)((dword)OsdBaseInfo.oAddr + 720*i); //odd field
    }
    for (y=iStartingRow; y<iEndingRow; y+=4) {  // scan entire screen-buffer, every 2nd line to save resource
        for (x=0; x <720; x+=6) {               //may as well only scan every 6 pixels to save time and resource
            if (*(pAddr[y] + x) != 0)           // return TRUE if value at any position
                return TRUE;
        }
    }
    return FALSE;
}
//----------------------------------------------------------------------------
void ShowMainChannelInfo()
{
    int channel_type, channel_number;

    TAP_Channel_GetCurrent(&channel_type, &channel_number);
    ShowChannelInfo(channel_type, channel_number);
}
//----------------------------------------------------------------------------
void ShowSubChannelInfo()
{
    int channel_number;

    TAP_Channel_GetCurrentSubTV(&channel_number);
    ShowChannelInfo(SVC_TYPE_Tv, channel_number);
}
//----------------------------------------------------------------------------
void ShowChannelInfo(int channel_type, int channel_number)
{
    TYPE_TapChInfo  channel_info;

    TAP_Channel_GetInfo(channel_type, channel_number, &channel_info);

/**
 * -----------------------------------------------------------------
 *      Sat: XXXXXXXXXXXXXXXX Chan: XXXXXXXXXXXXXXXXXXXXXXX
 *     Flag: XXXXX    Tuner: XX         Polar: X       Freq: XXXXXXX
 *       Sr: XXXXX    SvcID: XXXXX     PMTpid: XXXXX PCRpid: XXXXX
 * videoPid: XXXXX audioPid: XXXXX dolbyTrack: XXXXX  Multi: XXXXX
 *   satIdx: XXXXX orgNetId: XXXXX   tsId: XXXXX    lcn: XXXXX
 * -----------------------------------------------------------------
 */

//!!!
//frequency fails for dvbt
//!!!

//                    chInfo.dolbyTrack);       // 0xff = No Dolby Audio, other value = Dolby Track Number
//                    chInfo.multifeed);        // 0 = No Multifeed, other value = Subfeed Number

    TAP_Print("\n-------------------------------------------------------------------------------");
    TAP_Print("\nChan Num: %5d     Chan: %16s\n", channel_number, channel_info.chName);
    TAP_Print("\n    Flag: %05x    Tuner: %2x         Polar: %01x       Freq: %07x",
        channel_info.flag, (channel_info.tunerNum & 0x2), (channel_info.polar & 0x1), channel_info.freq);
    TAP_Print("\n      Sr: %05x    SvcID:  %04x     PMTpid:  %04x PCRpid:  %04x",
        channel_info.sr, channel_info.svcId, channel_info.pmtPid, channel_info.pcrPid);
    TAP_Print("\nvideoPid:  %04x audioPid:  %04x dolbyTrack:   %03x  Multi: %05x",
        channel_info.videoPid, channel_info.audioPid, channel_info.dolbyTrack, channel_info.multifeed);
    TAP_Print("\n  satIdx: %05x orgNetId:  %04x       tsId:  %04x    lcn: %5d",
        channel_info.satIdx, channel_info.orgNetId, channel_info.tsId, channel_info.logicalChNum);
}
//----------------------------------------------------------------------------
void ShowMainChannelEPG()
{
    int channel_type, channel_number;

    TAP_Channel_GetCurrent(&channel_type, &channel_number);
    ShowChannelEPG(channel_type, channel_number);
}
//----------------------------------------------------------------------------
void ShowSubChannelEPG()
{
    int channel_number;

    TAP_Channel_GetCurrentSubTV(&channel_number);
    ShowChannelEPG(SVC_TYPE_Tv, channel_number);
}
//----------------------------------------------------------------------------
void ShowChannelEPG(int channel_type, int channel_number)
{
    int event_num, i;
    byte st_day, st_month, st_hour, st_min, weekDay;
    byte end_day, end_month, end_hour, end_min;
    word st_year, end_year;
    word dur_hour, dur_min;
    TYPE_exTapEvent *evt_info;
    int current_event_num;

	evt_info = exTAP_GetCurrentEvent(channel_type, channel_number);
    current_event_num = evt_info->evtId;

    TAP_Print("\n-------------------------------------------------------------------------------");
    TAP_Print("\nCurrent Event ID:  %04x", current_event_num);
    TAP_MemFree(evt_info);

	evt_info = exTAP_GetEvent(channel_type, channel_number, &event_num);

    /**
     * -----------------------------------------------------------------
     * evtId: XXXXX  Running Status: XX                  Rating: XX
     * Start: XX/XX/XXXX XX:XX  End: XX/XX/XXXX XX:XX  Duration: XXH XXM
     *  Name: XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
     *  Desc: XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
     */

    for(i=0; i<event_num; i++)
    {
        TAP_Print("\n");
        if (evt_info[i].evtId == current_event_num)
            TAP_Print("\n- Current Event  %04x ---------------------------------------------------------", i);
        else
            TAP_Print("\n- Event  %04x -----------------------------------------------------------------", i);
        dumpEvent(&evt_info[i]);

        if (i > 4) break;
    }
    TAP_MemFree(evt_info);
}
//----------------------------------------------------------------------------
void dumpEvent(TYPE_exTapEvent *evt_info)
{
    int channel_type, channel_number, event_num, i;
    byte st_day, st_month, st_hour, st_min, weekDay;
    byte end_day, end_month, end_hour, end_min;
    word st_year, end_year;
    word dur_hour, dur_min;
    int current_event_num;

    /**
     * -----------------------------------------------------------------
     *           evtId: XXXXX          Running Status: XX
     *           svcId: XXXXX                   Start: XX/XX/XXXX XX:XX
     * Orig Network Id: XXXXX                     End: XX/XX/XXXX XX:XX
     * Trans Stream ID: XXXXX                Duration: XXH XXM
     *          Rating: XX
     * Name: XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
     * Desc: XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
     */

    TAP_ExtractMjd((evt_info->startTime >> 16), &st_year, &st_month, &st_day, &weekDay);
    st_hour = ((evt_info->startTime >> 8) & 0xFF);
    st_min  = (evt_info->startTime & 0xFF);

    TAP_ExtractMjd((evt_info->endTime >> 16), &end_year, &end_month, &end_day, &weekDay);
    end_hour    = ((evt_info->endTime >> 8) & 0xFF);
    end_min     = (evt_info->endTime & 0xFF);

    dur_hour    = (evt_info->duration / 60);
    dur_min     = (evt_info->duration % 60);

//  TAP_Print("\n-------------------------------------------------------------------------------");
    TAP_Print("\n          evtId: %04x    ", evt_info->evtId);
    TAP_Print("Running Status: (%x)%s", evt_info->runningStatus, get_str(running_status_str, evt_info->runningStatus));
    TAP_Print("\n          svcId: %04x    ", evt_info->svcId);
    TAP_Print("         Start: %02d:%02d:00 %02d/%02d/%04d", (int)st_hour, (int)st_min, (int)st_day, (int)st_month, (int)st_year);
    TAP_Print("\nOrig Network ID: %04x    ", evt_info->orgNetId);
    TAP_Print("           End: %02d:%02d:00 %02d/%02d/%04d", (int)end_hour, (int)end_min, (int)end_day, (int)end_month, (int)end_year);
    TAP_Print("\nTrans Stream ID: %04x    ", evt_info->tsId);
    TAP_Print("      Duration: %02d:%02d:00", (int)dur_hour, (int)dur_min);
    TAP_Print("\n         Rating: %4s     ", get_str(rating_str, evt_info->parentalRating));
    TAP_Print("\nName: %s", evt_info->eventName);
    TAP_Print("\nDesc: %s", evt_info->description);
}
//----------------------------------------------------------------------------
void dumpEvent1(TYPE_TapEvent *evt_info)
{
    int channel_type, channel_number, event_num, i;
    byte st_day, st_month, st_hour, st_min, weekDay;
    byte end_day, end_month, end_hour, end_min;
    word st_year, end_year;
    word dur_hour, dur_min;
    int current_event_num;

    /**
     * -----------------------------------------------------------------
     *           evtId: XXXXX          Running Status: XX
     *           svcId: XXXXX                   Start: XX/XX/XXXX XX:XX
     * Orig Network Id: XXXXX                     End: XX/XX/XXXX XX:XX
     * Trans Stream ID: XXXXX                Duration: XXH XXM
     *          Rating: XX
     * Name: XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
     * Desc: XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
     */

    TAP_ExtractMjd((evt_info->startTime >> 16), &st_year, &st_month, &st_day, &weekDay);
    st_hour = ((evt_info->startTime >> 8) & 0xFF);
    st_min  = (evt_info->startTime & 0xFF);

    TAP_ExtractMjd((evt_info->endTime >> 16), &end_year, &end_month, &end_day, &weekDay);
    end_hour    = ((evt_info->endTime >> 8) & 0xFF);
    end_min     = (evt_info->endTime & 0xFF);

    dur_hour    = (evt_info->duration / 60);
    dur_min     = (evt_info->duration % 60);


//  TAP_Print("\n-------------------------------------------------------------------------------");
    TAP_Print("\n          evtId: %04x    ", evt_info->evtId);
    TAP_Print("Running Status: (%x)%s", evt_info->runningStatus, get_str(running_status_str, evt_info->runningStatus));
    TAP_Print("\n          svcId: %04x    ", evt_info->svcId);
    TAP_Print("         Start: %02d:%02d:00 %02d/%02d/%04d", (int)st_hour, (int)st_min, (int)st_day, (int)st_month, (int)st_year);
    TAP_Print("\nOrig Network ID: %04x    ", evt_info->orgNetId);
    TAP_Print("           End: %02d:%02d:00 %02d/%02d/%04d", (int)end_hour, (int)end_min, (int)end_day, (int)end_month, (int)end_year);
    TAP_Print("\nTrans Stream ID: %04x    ", evt_info->tsId);
    TAP_Print("      Duration: %02d:%02d:00", (int)dur_hour, (int)dur_min);
    TAP_Print("\n         Rating: %4s     ", get_str(rating_str, evt_info->parentalRating));
    TAP_Print("\nName: %s", evt_info->eventName);
    TAP_Print("\nDesc: %s", evt_info->description);
}
//----------------------------------------------------------------------------
void dumpFileDetails(TYPE_File *file)
{
    word year;
    byte month;
    byte day;
    byte weekDay;

    if (file->name[0] == 0) {
//      fLOG(LOG_DEBUG, "Error, NULL file pointer");
        TAP_Print("\nError, NULL file pointer\n");
        return;
    }

    TAP_ExtractMjd(file->mjd, &year, &month, &day, &weekDay);
    if (year > 9999) {
        year    = 1970;
        month   = 1;
            day = 1;
    }

    if (file->attr != ATTR_FOLDER) {
        TAP_Print("\n---------------------------------------------------------------------------"
                  "\n     Name: %s"
                  "\nDatestamp: %04d-%02d-%02d %02d:%02d:%02d\tAttr: %s"
                  "\n      Pos: %05x\t\tsize: %x %08x"
                  "\n  Cluster: %05x\t\t Tot: %08x"
                  "\n   Unused: %05x\t\t",
            file->name,
            year, month, day, file->hour, file->min, file->sec,  get_str(attribute_str, file->attr),
            file->currentPos, *(dword *)(&file->size), *(dword *)(4+(int)&file->size),
            file->startCluster, file->totalCluster,
            file->unusedByte
        );
//        TAP_Print("\n      skip      : %02x", file->skip);
//        TAP_Print("\n      crypt     : %02x", file->crypt);
//        TAP_Print("\n      playLst   : %02x", file->playLst);
    }
    else {
        TAP_Print("\n---------------------------------------------------------------------------"
                  "\n   Folder: %s", file->name);
    }
}
//----------------------------------------------------------------------------
void dumpRecording(int slot)
{
    TYPE_RecInfo    rinfo;
    byte dummy2[0x80];
    TYPE_TapChInfo chinfo;

    /**
     * -- RECORDING XXX ----------------------------------------------
     *  Rec Type: XXXXXXXXX
     *     Tuner: X
     *   Service: XXXXX - XXX - XXXXXXXXXXXXXXXXXXXX
     *     Start: XXXX-XX-XX XX:XX:XX Duration: XXX
     *       End: XXXX-XX-XX XX:XX:XX Recorded: XXXXX secs
     *      Name: XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
     */
    /**
     * -- RECORDING XXX ----------------------------------------------
     *  Rec Type: XXXXXXXXX
     *     Tuner: X
     *   Service: XXXXX - XXX - XXXXXXXXXXXXXXXXXXXX
     *     Start: XXXX-XX-XX XX:XX:XX Duration: XXX
     *       End: XXXX-XX-XX XX:XX:XX Recorded: XXXXX secs
     *      Name: XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
     */

    if (TAP_Hdd_GetRecInfo((byte)slot, &rinfo)) {
        TAP_Channel_GetInfo(rinfo.svcType, rinfo.svcNum, &chinfo);
        TAP_Print("\n-- RECORDING %03d ----------------------------------------------------------", slot);
        TAP_Print("\n Rec Type: %9s", get_str(rectype_str, rinfo.recType));
        TAP_Print("\n    Tuner: %1d", rinfo.tuner);
        TAP_Print("\n  Service: %5s - %3d - %s", get_str(service_type_str, rinfo.svcType), rinfo.svcNum, chinfo.chName);
        TAP_Print("\n    Start: %19s  Duration: %02d:%02d:00", mjdToString(rinfo.startTime), rinfo.duration/60, rinfo.duration%60);
        TAP_Print("\n      End: %19s  Recorded: %02d:%02d:00", mjdToString(rinfo.endTime), rinfo.recordedSec/60, rinfo.recordedSec%60);
        TAP_Print("\n     Name: %s\n", rinfo.fileName);
        TAP_Print("\n---------------------------------------------------------------------------");
    }
    else
    {
        TAP_Print("\n-- RECORDING %03d ----------------------------------------------------------", slot);
        TAP_Print("\nEmpty");
    }
}
//----------------------------------------------------------------------------
void dumpPlaying()
{
    TYPE_PlayInfo pinfo;
    byte dummy2[0x80];
    TYPE_TapChInfo chinfo;

    /**
     * -- PLAYING XXX ------------------------------------------------
     * Play Mode: XXXXXXXXXXXX  Trick Mode: XXXXXXX  Speed: X
     *   Service: XXXXX - XXX - XXXXXXXXXXXXXXXXXXXX
     *  Duration: XXX
     *     Block: XXXXX/XXXXX
     *       End: XXXX-XX-XX XX:XX:XX Recorded: XXXXX secs
     *      Name: XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
     */

    TAP_Hdd_GetPlayInfo(&pinfo);
    TAP_Channel_GetInfo(pinfo.svcType, pinfo.svcNum, &chinfo);
    TAP_Print("\n-- PLAYING --------------------------------------------------------------------");
    TAP_Print("\n Play Mode: %11s  ", get_str(playmode_str, pinfo.playMode));
    TAP_Print("Trick Mode: %7s  ", get_str(trickmode_str, pinfo.trickMode));
    TAP_Print("Speed: x%d", pinfo.speed);

    TAP_Print("\n   Service: %5s - %3d - %s", get_str(service_type_str, pinfo.svcType), pinfo.svcNum, chinfo.chName);
    TAP_Print("\n  Duration: %02d:%02d:00", pinfo.duration/60, pinfo.duration%60);
    TAP_Print("\n     Block: %5d/%5d", pinfo.currentBlock, pinfo.totalBlock);
    TAP_Print("\n  Repeat Status: %02x", pinfo.repeatStatus);
    TAP_Print("\n-------------------------------------------------------------------------------");
    TAP_Print("\n      File:");
    if (pinfo.file) {
        TAP_Print("\n      attr      : %s", get_str(attribute_str,  pinfo.file->attr));
        TAP_Print("\n      name      : %s", pinfo.file->name);
        TAP_Print("\n      skip      : %02x", pinfo.file->skip);
        TAP_Print("\n      crypt     : %02x", pinfo.file->crypt);
        TAP_Print("\n      playLst   : %02x", pinfo.file->playLst);
        TAP_Print("\n      size      : %x %08x", *(dword *)(&pinfo.file->size), *(dword *)(4+(int)&pinfo.file->size));
        TAP_Print("\n      currentPos: %x", pinfo.file->currentPos);
    }
    TAP_Print("\n-------------------------------------------------------------------------------");
    TAP_Print("\n     Event:");
//!!!not exTapEvent
//    dumpEvent((TYPE_exTapEvent *)&pinfo.evtInfo);
    dumpEvent1((TYPE_TapEvent *)&pinfo.evtInfo);
    TAP_Print("\n-------------------------------------------------------------------------------");
    TAP_Print("\n");
}
//----------------------------------------------------------------------------
void dumpTimer(int timerNo)
{
    TYPE_TimerInfo tinfo;
    TYPE_TapChInfo chinfo;

    /**
     * -- TIMER XXX ----------------------------------------------
     *  Rec Type: XXXXXXXXX           Res Type: XXXXXXXXXXXX      Name Fixed: XXX
     *     Tuner: X
     *   Service: XXXXX - XXX - XXXXXXXXXXXXXXXXXXXX
     *     Start: XXXX-XX-XX XX:XX:XX Duration: XXX
     *      Name: XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
     */

    if (TAP_Timer_GetInfo(timerNo, &tinfo))
    {
        TAP_Channel_GetInfo(tinfo.svcType, tinfo.svcNum, &chinfo);
        TAP_Print("\n-- TIMER %03d --------------------------------------------------------------", timerNo);
        TAP_Print("\n Rec Type: %9s        Res Type: %12s  Name Fixed: %3s", get_str(rectype_str, tinfo.isRec), get_str(reserve_type_str, tinfo.reservationType)/*DecodeReservationType(tinfo.reservationType)*/ + 13, (tinfo.nameFix == 1) ? "YES" : "NO");
        TAP_Print("\n    Tuner: %1d", tinfo.tuner);
        TAP_Print("\n  Service: %5s - %3d - %s", get_str(service_type_str, tinfo.svcType), tinfo.svcNum, chinfo.chName);
        TAP_Print("\n    Start: %19s Duration: %02d:%02d:00", mjdToString(tinfo.startTime), tinfo.duration/60, tinfo.duration%60);
        TAP_Print("\n     Name: %s", tinfo.fileName);
        TAP_Print("\n---------------------------------------------------------------------------");
    }
    else
    {
        TAP_Print("\n-- TIMER %03d --------------------------------------------------------------", timerNo);
        TAP_Print("\nEmpty\n");
        TAP_Print("\n---------------------------------------------------------------------------");
    }
}
//----------------------------------------------------------------------------
//benchmark(0,"");
//benchmark(1,"message");
void benchmark(int state, char *str)
{
    static dword stime = 0;
    dword etime;

    if (state) {
        etime = TAP_GetTick();
        TAP_Print("\n%s took: %dms", str, (etime-stime)*10);
        stime = TAP_GetTick();
    }
    else {
        stime = TAP_GetTick();
    }
}
//----------------------------------------------------------------------------
void to_bytes(ulong64 value64)
{
    dword high,low;

    high = *(dword *)((dword)&value64);
    low = *(dword *)((dword)&value64+4);


    if ((high == 0) && (low < 0x400)) {
        TAP_Print(", %7d  bytes ", low);
    }
    else
    if ((high == 0) && (low < 0x100000)) {
        TAP_Print(", %4d.%02d Kbytes", low/0x400, (low%0x400)*100/0x400);
    }
    else
    if ((high == 0) && (low < 0x40000000)) {
        TAP_Print(", %4d.%02d Mbytes", low/0x100000, (low%0x100000)*100/0x100000);
    }
//    else
//    if (high == 0) {
//        TAP_Print(", %4d.%02d Gbytes", low/0x40000000, (low%0x40000000)/0xA3D70A);
//    }
    else {
        TAP_Print(", %4d.%02d Gbytes", high*4+low/0x40000000, (low%0x40000000)/0xa3d70a);
    }
}
//----------------------------------------------------------------------------
